﻿using System;
using System.Collections.Generic;
using System.Text;
using Syncfusion.Core;
using Syncfusion.Licensing;
using Syncfusion.XlsIO;
using System.IO;
using System.Globalization;

namespace AppendXlsx
{
    class Program
    {

        static void Main(string[] args)
        {
            // clone model file to destination file
            File.Copy("c:\\tmp\\analisi vendite per esercizio.xls", "c:\\tmp\\chiara_dest3.xls", true);

            XlsFile myFile = new XlsFile("c:\\tmp\\chiara_dest3.xls");

            myFile.Open (appendFile:true, pageNumber:0, pageName:"COVER", xlsxExtension:false, columnCount:10);

            myFile.Close();

        }

        /*
        static void MainOld(string[] args)
        {
            // clone model file to destination file
            File.Copy("c:\\tmp\\AARISORSE - dati vuoti 2010.xlsx", "c:\\tmp\\destination 2010 - write DATI sheet.xlsx", true);

            XlsFile myFile = new XlsFile("c:\\tmp\\destination 2010 - write DATI sheet.xlsx");

            myFile.Open(appendFile: true, pageNumber: 0, pageName: "DATI", xlsxExtension: true, columnCount: 37);

            for (long line = 1; line < 5000; line++)
            {
                myFile.WriteLine(line);
            }

            myFile.Close();


            File.Copy("c:\\tmp\\AARISORSE - dati vuoti 2010.xlsx", "c:\\tmp\\destination 2010 - write Foglio 2 sheet.xlsx", true);

            XlsFile myFile2 = new XlsFile("c:\\tmp\\destination 2010 - write Foglio 2 sheet.xlsx");

            myFile2.Open(appendFile: true, pageNumber: 0, pageName: "Foglio2", xlsxExtension: true, columnCount: 37);

            for (long line = 1; line < 5000; line++)
            {
                myFile2.WriteLine(line);
            }

            myFile2.Close();

        }
        */


    }


    class XlsFile
    {
        private string _filePath;
        private ExcelEngine _excelEngine;
        private IWorkbook _workBook;
        private IWorksheet _sheet;
        private int _line;
        private int _column;
        private int _columnHeader;
        private bool _autofit = true;
        private CultureInfo _culture = new CultureInfo("it-IT");

        public XlsFile(string filePath)
        {
            _filePath = filePath;
        }

        public bool Open(bool appendFile, int pageNumber, string pageName, bool xlsxExtension, int columnCount)
        {
            _excelEngine = new ExcelEngine();

            string defaultDes = "Foglio";

            IApplication application = _excelEngine.Excel;
            application.CompressionLevel = Syncfusion.Compression.CompressionLevel.Best; // cm 2107

            if (appendFile)
            {
                if (File.Exists(_filePath))
                    _workBook = application.Workbooks.Open(_filePath);
                else
                {
                    appendFile = false;
                    _workBook = application.Workbooks.Create(1);

                    for (int i = 0; i < _workBook.Worksheets.Count; i++)
                    {
                        _workBook.Worksheets[i].Name = defaultDes + (i + 1).ToString();
                    }
                }
            }
            else
            {
                if (pageNumber == 0 || !string.IsNullOrEmpty(pageName))
                    _workBook = application.Workbooks.Create(1);
                else
                    _workBook = application.Workbooks.Create(pageNumber);

                for (int i = 0; i < _workBook.Worksheets.Count; i++)
                {
                    _workBook.Worksheets[i].Name = defaultDes + (i + 1).ToString();
                }
            }


            if (string.IsNullOrEmpty(pageName))
            {
                if (pageNumber > 0)
                    _sheet = _workBook.Worksheets[pageNumber - 1];
                else
                    _sheet = _workBook.Worksheets[0];
            }
            else
            {
                _sheet = _workBook.Worksheets[pageName];
                if (_sheet == null)
                {
                    if (appendFile)
                        _sheet = application.Worksheets.Create(pageName);
                    else
                    {
                        _sheet = _workBook.Worksheets[0];
                        _sheet.Name = pageName;
                    }
                }
            }

            // calcolo la riga a partire da cui iniziare a scrivere
            ValFirstFreeLine(columnCount);

            if (xlsxExtension)
                _workBook.Version = ExcelVersion.Excel2007;
            else
                _workBook.Version = ExcelVersion.Excel97to2003;

            _workBook.DetectDateTimeInValue = false; // ottimizza prestazioni - cm 2107

            return true;

        }


        private bool ValFirstFreeLine(int columnCount)
        {
            // chiedo di escludere le celle piene ma solo con la formattazione!
            _sheet.UsedRangeIncludesFormatting = false;

            IRange range = null;
            bool exception = false;

            // Chiara, 01.09.15: in alcuni casi (es. su esportazioni con modello basilea2 - foglio dati_sp, dati_ce...)
            // la richiesta dello UsedRange produce una eccezione (poiché hanno inserito delle formattazioni "strane"? ci sono colonne/celle evidenziate)
            // Gestisco quindi la possibilità di avere una eccezione... e la tratto come se il foglio fosse vuoto
            try
            {
                range = _sheet.UsedRange;
            }
            catch (Exception ex)
            {
                exception = true;
            }


            int nMaxCell = range.Cells.Length;
            if (nMaxCell <= 0)
            {
                _sheet.UsedRangeIncludesFormatting = true;
                return false;
            }

            bool emptyCellFound = false;

            IRange[] cells = _sheet.UsedRange.Cells;

            for (int index = 0; index < nMaxCell - 1; index++)
            {
                IRange cell = cells[index];

                if (String.IsNullOrEmpty(cell.Value))
                {
                    emptyCellFound = true;
                }
                else
                {
                    if (cell.Column <= columnCount)
                    {
                        emptyCellFound = false;

                        _line = cell.Row;
                    }
                }

                if (cell.EntireColumn.ColumnWidth != _sheet.StandardWidth)
                    _autofit = false;

            }

            _sheet.UsedRangeIncludesFormatting = true;
            return true;
        }


        public void Close()
        {
            if (_excelEngine == null)
                return;

            IWorksheet sheet = null;

            sheet = _sheet;
            /*
            sheet.UsedRangeIncludesFormatting = true;
            if (_autofit)
            {
                sheet.UsedRange.AutofitColumns();
                sheet.UsedRange.AutofitRows();
            }
            else
            {
                int numCols = sheet.UsedRange.Columns.Length;  // ottimizza prestazioni - cm 2107

                for (int index2 = 0; index2 < numCols - 1; index2++)
                {
                    if (sheet.UsedRange.Columns[index2].ColumnWidth == sheet.StandardWidth)
                        sheet.UsedRange.Columns[index2].AutofitColumns();
                }
            }
             */

            _workBook.SaveAs(_filePath);
            _workBook.Close();
            _excelEngine.Dispose();

            _excelEngine = null;

        }


        public void ChangeSheet(int index)
        {
            _sheet = _workBook.Worksheets[index - 1];
            _line = _sheet.Rows.Length;
            _column = 0;
        }

        public void CreateSheet(int index, string name)
        {
            _sheet = _workBook.Worksheets.Create();

            if (string.IsNullOrEmpty(name))
                _sheet.Name = string.Format("Foglio{0}", index);
            else
                _sheet.Name = name;

            _line = 0;
            _column = 0;
        }


        public void WriteLine(long line)
        {
            for (long i = 0; i < 37; i++)
            {
                Object xlsValue = null;
                XlsValueType xlsValueType;
                string format;
                if (i<20)
                {
                    xlsValue = "Cella riempita con del testo generico";
                    xlsValueType = XlsValueType.String;
                    format = "@";
                }
                else
                {
                    double dVal = i*10000 + i + i/200;
                    xlsValue = dVal;
                    xlsValueType =  XlsValueType.Number;
                    format = "0";
                }

                Append(xlsValue, xlsValueType, format);
            }

            Write();
        }





        public void Append(object value, XlsValueType typeValue, string format)
        {

            if ((_column >= 255) && (_workBook.Version == ExcelVersion.Excel97to2003))
                return;

            IRange cell = _sheet.Range[_line + 1, _column + 1];

            // IMigrantRange cell = _sheet.MigrantRange; // ottimizza prestazioni - cm 2107
            // cell.ResetRowColumn(_line + 1, _column + 1);

            cell.NumberFormat = format;

            if (value != null)
            {
                try
                {
                    if (typeValue == XlsValueType.Number)
                        cell.Number = Convert.ToDouble(value, _culture);
                    else if (typeValue == XlsValueType.String )
                    {
                        string text = Convert.ToString(value, _culture);

                        if (text.Contains("\r\n"))
                            text = text.Replace("\r\n", "\n");

                        if (text.Contains("\r"))
                            text = text.Replace("\r", "\n");

                        cell.Text = Convert.ToString(text, _culture);

                        // Mirko Salvia - 17/01/2013    
                        // Correzione segnalazione ID 77847
                        // Se il valore testo da esportare supera i 255 caratteri
                        // allora il formato della cella deve essere di tipo
                        // Generale. Altrimenti Excel inserisce ######
                        if ((cell.Text != null) && (cell.Text.Length > 255))
                            cell.NumberFormat = "General";
                    }
                    else
                        cell.Value2 = value;
                }
                catch (Exception ex)
                {
                }

            }

            _sheet.Range[_line + 1, _column + 1] = cell;

            _column += 1;

        }

        public bool Write()
        {
            _column = 0;
            _line += 1;

            int delta = _line - ((_line / 1000) * 1000);

            if (delta == 0) 
            {
                System.Windows.Forms.MessageBox.Show(String.Format("{0} rows written", _line));
                // _workBook.SaveAs(_filePath);
            }

            return true;
        }




    }

    /// <summary>
    /// Tipologie di valore da inserire nella cella
    /// </summary>
    public enum XlsValueType
    {
        Number,
        Date,
        String,
        Other
    }


}
